.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm		; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

ShowCpu	PROTO:DWORD

LOOP_COUNT =	1000000
cyct_subct =	LOOP_COUNT/1000 		; 1000 entries in cyct_table
SleepMs =	50	; Invoke Sleep, SleepMs
CutFast =	10	; # of timings to be cut off on the fast side	
CutSlow =	300	; # of timings to be cut off on the slow side
MakeFast =	1

cyct_begin MACRO
  tmp$ CATSTR <Lc=>, %LOOP_COUNT, <, SubCt=>, %cyct_subct
  % echo tmp$
  if cyct_subct lt 100
  	cyct_subct = 100
  	echo increased to 100
  endif
  and cyct_counter, 0			;; clear the counter
  invoke Sleep, SleepMs
  .Repeat
	counter_begin cyct_subct, HIGH_PRIORITY_CLASS
ENDM
;		mov eax, len(offset Tst50)
cyct_end MACRO arg
LOCAL tmp$
  counter_end
  	mov edx, cyct_counter
  	mov [cyct_table+4*edx], eax
	inc cyct_counter
  .Until edx>=sizeof cyct_table/4
  inc edx
  invoke CombSortA, offset cyct_table, edx
  xor ebx, ebx
  .Repeat
  	print str$(ebx), ":"
	mov eax, [cyct_table+4*ebx]
	if 1
		print str$(eax), " "
	else
		print str$(eax), 9
		tmp$ CATSTR <print " cycles for ">, <, 9, ">, <arg>, <", 13, 10>
		;% echo tmp$
		tmp$
	endif
  	inc ebx
  .Until ebx>CutFast
  print chr$(13, 10, 10, "...", 13, 10, 10)
  mov ebx, cyct_counter
  sub ebx, CutSlow
  .Repeat
  	print str$(ebx), ":"
	mov eax, [cyct_table+4*ebx]
	if 1
		print str$(eax), " "
	else
		print str$(eax), 9
		tmp$ CATSTR <print " cycles for ">, <, 9, ">, <arg>, <", 13, 10>
		;% echo tmp$
		tmp$
	endif
  	inc ebx
  .Until ebx>=cyct_counter
  tmp$ CATSTR <print chr$(13, 10, ">, <arg>, <: subcounter=",9)>
;  % echo tmp$
  tmp$
  print str$(cyct_subct), 13, 10, "average with cutoff", 9
  m2m ebx, CutFast

  push esi
  mov eax, [cyct_table+4*CutSlow]	; determine the cutoff value
  mov esi, eax			; eax is one of the lowest timings
  shr esi, 2			; /4
  inc esi
  add esi, eax			; esi = eax * 1.25 + 1
  xor eax, eax
  .Repeat
	mov ecx, [cyct_table+4*ebx]
	.Break .if ecx>esi
	add eax, ecx
	inc ebx
  .Until ebx>cyct_counter
  sub ebx, CutFast
  cdq
  div ebx
  push eax
  print str$(eax), "  ", 9, "cutoff at n="
  add ebx, CutFast
  print str$(ebx), " for ct higher than "
  print str$(esi), " cycles"

  print chr$(13, 10, "average w/o cutoff ", 9)
  xor eax, eax
  xor ebx, ebx
  mov edx, cyct_counter
  ; sub edx, CutSlow
  .Repeat
	add eax, [cyct_table+4*ebx]
	inc ebx
  .Until ebx>edx
  ; sub ebx, CutFast
  cdq
  div ebx
  mov ebx, eax
  print str$(eax), 13, 10, "difference raw-cutoff:", 9
  pop eax
  pop esi
  sub ebx, eax
  print str$(ebx)

ENDM

.data?
cyct_counter	dd ?
cyct_table	dd 1000 dup(?)

.data
Tst50	db "This is a string with exactly 50 characters ------", 0

.code
start:
	invoke ShowCpu, 1	; prints the brand string and returns SSE level in eax
	print "Testing timings with cutoff", 13, 10, 10

	MyTest equ <mov eax, len(offset Tst50)>

	cyct_begin
		if 0
			push eax
			push ecx
			push edx
			push edi
			push esi
			push eax
			pop ecx
			pop esi
			pop edi
			pop eax
			pop ecx
			pop edx
		else
			MyTest
		endif
	cyct_end MyTest
	if MakeFast
		REPEAT 200
		nop
		ENDM
	endif

	inkey chr$(13, 10, 10, "*** ok - press any key ***")
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
ShowCpue:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

end start
OPT_WAIT	0
OPT_Tmp2Asm	1

Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
Testing timings with cutoff, subcounter=10000

0:151 1:151 2:151 3:151 4:151 5:151 6:151 7:151 8:151 9:151 10:151 11:151 12:151
 13:151 14:151 15:151 16:151 17:151 18:151 19:151 20:151

...

801:152 802:152 803:152 804:152 805:152 806:152 807:152 808:152 809:152 810:152
811:152 812:152 813:152 814:152 815:152 816:152 817:152 818:152 819:153 820:153
821:154 822:154 823:154 824:154 825:155 826:155 827:155 828:155 829:155 830:155
831:155 832:155 833:156 834:156 835:156 836:157 837:157 838:157 839:157 840:157
841:157 842:157 843:157 844:157 845:157 846:157 847:157 848:157 849:157 850:157
851:157 852:157 853:157 854:158 855:158 856:158 857:158 858:158 859:159 860:159
861:159 862:159 863:159 864:159 865:160 866:160 867:160 868:160 869:160 870:161
871:162 872:163 873:163 874:163 875:164 876:164 877:165 878:165 879:170 880:170
881:172 882:173 883:175 884:176 885:178 886:179 887:180 888:187 889:188 890:188
891:188 892:188 893:188 894:188 895:188 896:188 897:188 898:188 899:188 900:188
901:189 902:193 903:202 904:203 905:205 906:226 907:231 908:232 909:243 910:244
911:248 912:252 913:260 914:263 915:263 916:263 917:263 918:264 919:264 920:264
921:264 922:265 923:265 924:265 925:265 926:265 927:265 928:265 929:266 930:266
931:266 932:266 933:267 934:267 935:267 936:267 937:268 938:268 939:268 940:268
941:268 942:268 943:268 944:268 945:268 946:269 947:269 948:269 949:269 950:269
951:269 952:270 953:270 954:270 955:270 956:270 957:270 958:270 959:270 960:270
961:270 962:270 963:270 964:270 965:270 966:270 967:270 968:270 969:270 970:270
971:270 972:271 973:271 974:271 975:271 976:272 977:272 978:272 979:272 980:272
981:273 982:273 983:273 984:273 985:273 986:273 987:274 988:275 989:280 990:280
991:281 992:281 993:282 994:282 995:288 996:288 997:297 998:305 999:312 1000:331

MyTest: subcounter=     10000
average with cutoff     151
average w/o cutoff      164